diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
index 0ec8ed312..79b263d9c 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
@@ -18,8 +18,8 @@ public final class BlockColorDispatcher
     private BlockColorDispatcher()
     {
         addDispatch(Block.algae, new BlockColorCustom(Colorizers.grass));
-        addDispatch(Block.fluidWaterStill, new BlockColorCustom(Colorizers.water));
-        addDispatch(Block.fluidWaterFlowing, new BlockColorCustom(Colorizers.water));
+        addDispatch(Block.fluidWaterStill, new BlockColorWater(Colorizers.water));
+        addDispatch(Block.fluidWaterFlowing, new BlockColorWater(Colorizers.water));
         addDispatch(Block.grass, new BlockColorCustom(Colorizers.grass));
         addDispatch(Block.layerLeavesOak, new BlockColorCustom(Colorizers.oak));
         addDispatch(Block.leavesBirch, new BlockColorCustom(Colorizers.birch));
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
new file mode 100644
index 000000000..ca43c3990
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
@@ -0,0 +1,31 @@
+package net.minecraft.client.render.block.color;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.colorizer.Colorizer;
+import net.minecraft.core.world.WorldSource;
+
+public class BlockColorWater extends BlockColorCustom {
+
+	public Minecraft mc = Minecraft.getMinecraft(this);
+	
+	public BlockColorWater(Colorizer colorizer) {
+		super(colorizer);
+	}
+	
+	@Override
+	public int getFallbackColor(int meta) {
+		if(!mc.gameSettings.biomeWater.value) {
+			return 0xFFFFFFFF;
+		}
+		return super.getFallbackColor(meta);
+	}
+	
+	@Override
+	public int getWorldColor(WorldSource world, int x, int y, int z) {
+		if(!mc.gameSettings.biomeWater.value) {
+			return 0xFFFFFFFF;
+		}
+		return super.getWorldColor(world, x, y, z);
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
index e1e4eb374..d7a654b06 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
@@ -36,25 +36,25 @@ public class BlockModelCandle<T extends Block> extends BlockModelStandard<T> {
 
         double uOffset = isLit ? 0.0f : (onePix * 3);
 
-        double sideMinU = texU + uOffset;
-        double sideMaxU = texU + uOffset + (onePix * 3);
-        double sideMinV = texV + (onePix * 3);
-        double sideMaxV = texV + (onePix * 3) + (onePix * 8);
+        double sideMinU = texIndex.getSubIconU(uOffset);
+        double sideMaxU = texIndex.getSubIconU(uOffset + (onePix * 3));
+        double sideMinV = texIndex.getSubIconV((onePix * 3));
+        double sideMaxV = texIndex.getSubIconV((onePix * 3) + (onePix * 8));
 
-        double topMinU = texU + uOffset;
-        double topMaxU = texU + uOffset + (onePix * 3);
+        double topMinU = texIndex.getSubIconU(uOffset);
+        double topMaxU = texIndex.getSubIconU(uOffset + (onePix * 3));
         double topMinV = texV;
-        double topMaxV = texV + (onePix * 3);
+        double topMaxV = texIndex.getSubIconV(onePix * 3);
 
-        double bottomMinU = texU + (onePix * 3);
-        double bottomMaxU = texU + (onePix * 3) + (onePix * 3);
+        double bottomMinU = texIndex.getSubIconU(onePix * 3);
+        double bottomMaxU = texIndex.getSubIconU((onePix * 3) + (onePix * 3));
         double bottomMinV = texV;
-        double bottomMaxV = texV + (onePix * 3);
+        double bottomMaxV = texIndex.getSubIconV(onePix * 3);
 
-        double wickMinU = texU + (onePix * 6) + uOffset;
-        double wickMaxU = texU + (onePix * 6) + uOffset + (onePix * 3);
+        double wickMinU = texIndex.getSubIconU((onePix * 6) + uOffset);
+        double wickMaxU = texIndex.getSubIconU((onePix * 6) + uOffset + (onePix * 3));
         double wickMinV = texV;
-        double wickMaxV = texV + (onePix * 6);
+        double wickMaxV = texIndex.getSubIconV(onePix * 6);
 
 
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
index 5a71c2498..56fae4788 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFire;
+import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 
 public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
@@ -28,8 +29,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
         }
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-        	// TODO skylight
-        	tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(0));
+        	tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(renderBlocks.blockAccess.getSavedLightValue(LightLayer.Sky, x, y, z)));
         }else {
         	brightness = renderBlocks.getBlockBrightness(renderBlocks.blockAccess, x, y, z);
         }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
index 834b15979..865ee6499 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockRail;
+import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
@@ -35,8 +36,7 @@ public class BlockModelRail<T extends BlockRail> extends BlockModelStandard<T> {
 		float brightness = 1.0f;
 		if(LightmapHelper.isLightmapEnabled()) {
 			if(renderBlocks.overbright) {
-				// TODO use correct skylight value, requires a getSavedLightValue method in WorldSource
-				tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(0));
+				tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(renderBlocks.blockAccess.getSavedLightValue(LightLayer.Sky, x, y, z)));
 			}else {
 				tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
 			}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
index a066dbe3f..4c53551ab 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
@@ -1,14 +1,14 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockRedstoneRepeater;
-import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
+@SuppressWarnings("unchecked")
 public class BlockModelRepeater extends BlockModelStandard<BlockRedstoneRepeater> {
-    private static final BlockModelTorch<Block> modelTorchActive = (BlockModelTorch<Block>) BlockModelDispatcher.getInstance().getDispatch(Block.torchRedstoneActive);
+	private static final BlockModelTorch<Block> modelTorchActive = (BlockModelTorch<Block>) BlockModelDispatcher.getInstance().getDispatch(Block.torchRedstoneActive);
     private static final BlockModelTorch<Block> modelTorchIdle = (BlockModelTorch<Block>) BlockModelDispatcher.getInstance().getDispatch(Block.torchRedstoneIdle);
 
     public BlockModelRepeater(Block block) {
@@ -17,16 +17,24 @@ public class BlockModelRepeater extends BlockModelStandard<BlockRedstoneRepeater
 
     public boolean render(Tessellator tessellator, int x, int y, int z){
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-        int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        int i1 = l & 3;
-        int j1 = (l & 0xc) >> 2;
+        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        int i1 = meta & 3;
+        int j1 = (meta & 0xc) >> 2;
         renderStandardBlock(tessellator, block, x, y, z);
-        float f = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-        if(Block.lightEmission[block.id] > 0)
-        {
-            f = (f + 1.0F) * 0.5F;
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
+        	if(Block.lightEmission[block.id] > 0) {
+        		lmc = LightmapHelper.setBlocklightValue(lmc, 15);
+        	}
+        	tessellator.setLightmapCoord(lmc);
+        }else {
+    		brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+    		if(Block.lightEmission[block.id] > 0) {
+    			brightness = 1.0f;
+    		}	
         }
-        tessellator.setColorOpaque_F(f, f, f);
+        tessellator.setColorOpaque_F(brightness, brightness, brightness);
         double d = -0.1875D;
         double d1 = 0.0D;
         double d2 = 0.0D;
@@ -57,46 +65,6 @@ public class BlockModelRepeater extends BlockModelStandard<BlockRedstoneRepeater
         BlockModelTorch<Block> modelTorch = block.isRepeaterPowered ? modelTorchActive : modelTorchIdle;
         modelTorch.renderTorchAtAngle(tessellator, (double)x + d1, (double)y + d, (double)z + d2, 0.0D, 0.0D);
         modelTorch.renderTorchAtAngle(tessellator, (double)x + d3, (double)y + d, (double)z + d4, 0.0D, 0.0D);
-        IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.TOP, l);
-        double d5 = texture.getIconUMin();
-        double d6 = texture.getIconUMax();
-        double d7 = texture.getIconVMin();
-        double d8 = texture.getIconVMax();
-        float f1 = 0.125F;
-        float f2 = x + 1;
-        float f3 = x + 1;
-        float f4 = x;
-        float f5 = x;
-        float f6 = z;
-        float f7 = z + 1;
-        float f8 = z + 1;
-        float f9 = z;
-        float f10 = (float)y + f1;
-        if(i1 == 2)
-        {
-            f2 = f3 = x;
-            f4 = f5 = x + 1;
-            f6 = f9 = z + 1;
-            f7 = f8 = z;
-        } else
-        if(i1 == 3)
-        {
-            f2 = f5 = x;
-            f3 = f4 = x + 1;
-            f6 = f7 = z;
-            f8 = f9 = z + 1;
-        } else
-        if(i1 == 1)
-        {
-            f2 = f5 = x + 1;
-            f3 = f4 = x;
-            f6 = f7 = z + 1;
-            f8 = f9 = z;
-        }
-        tessellator.addVertexWithUV(f5, f10, f9, d5, d7);
-        tessellator.addVertexWithUV(f4, f10, f8, d5, d8);
-        tessellator.addVertexWithUV(f3, f10, f7, d6, d8);
-        tessellator.addVertexWithUV(f2, f10, f6, d6, d7);
         return true;
     }
     @Override
@@ -107,6 +75,6 @@ public class BlockModelRepeater extends BlockModelStandard<BlockRedstoneRepeater
     @Override
     public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side)
     {
-        return side != 0 && side != 1;
+        return true;
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java
index 984a03bca..3c28efe3e 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java
@@ -1,24 +1,19 @@
 package net.minecraft.client.render.dynamictexture;
 
-import net.minecraft.client.render.stitcher.AtlasStitcher;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 
 public abstract class DynamicTexture {
 
-	public final IconCoordinate texture;
+	public IconCoordinate texture;
+	public byte[] imageData;
 	
-	public final byte[] imageData;
+	public abstract void postInit();
 	
-	public DynamicTexture(IconCoordinate texture) {
-		this.texture = texture;
-		
-		this.imageData = new byte[texture.getArea() * 4];
-	}
-
 	public abstract void update();
 	
-	public AtlasStitcher getTexture(){
-		return texture.parentAtlas;
+	public void setTexture(IconCoordinate texture) {
+		this.texture = texture;
+		this.imageData = new byte[texture.width * texture.height * 4];
 	}
 	
 	public static int pmod(int a, int b) {
@@ -38,27 +33,4 @@ public abstract class DynamicTexture {
 		array[i * 4 + 3] = (byte) a;
 	}
 	
-//	public static void main(String[] args) {
-//		for(int i = -16; i <= 16; i++) {
-//			int a = i & 15;
-//			int b = i % 16;
-//			int c = pmod(i, 16);
-//			System.out.println(expand(3, ""+i)+" "+expand(3, ""+a)+" "+expand(3, ""+b)+" "+expand(3, ""+c));
-//		}
-//		System.out.println("---");
-//		for(int i = -16; i <= 16; i++) {
-//			int a = i & 23;
-//			int b = i % 24;
-//			int c = pmod(i, 24);
-//			System.out.println(expand(3, ""+i)+" "+expand(3, ""+a)+" "+expand(3, ""+b)+" "+expand(3, ""+c));
-//		}
-//	}
-//	
-//	public static String expand(int length, String str) {
-//		while(str.length() < length) {
-//			str = " "+str;
-//		}
-//		return str;
-//	}
-	
 }
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
index 27f8f0081..f31003ef1 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
@@ -15,11 +15,11 @@ public class DynamicTextureCalendar extends DynamicTextureAbstractClock {
 	@Override
 	public double getAngle() {
 		double d = 0.0;
-		if (minecraft.theWorld != null && minecraft.thePlayer != null)
+		if (mc.theWorld != null && mc.thePlayer != null)
 		{
-			if (minecraft.theWorld.getSeasonManager() instanceof SeasonManagerCycle)
+			if (mc.theWorld.getSeasonManager() instanceof SeasonManagerCycle)
 			{
-				SeasonManagerCycle cycleManager = (SeasonManagerCycle) minecraft.theWorld.getSeasonManager();
+				SeasonManagerCycle cycleManager = (SeasonManagerCycle) mc.theWorld.getSeasonManager();
 				float f = cycleManager.getYearProgress() - 0.25f;
 				d = f * Math.PI * 2;
 			}
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
index 406e260b0..dd23db0e3 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
@@ -15,10 +15,10 @@ public class DynamicTextureClock extends DynamicTextureAbstractClock{
 	@Override
 	public double getAngle() {
 		double d = 0.0;
-		if(minecraft.theWorld != null && minecraft.thePlayer != null) {
-			float f = minecraft.theWorld.getCelestialAngle(1.0f);
+		if(mc.theWorld != null && mc.thePlayer != null) {
+			float f = mc.theWorld.getCelestialAngle(1.0f);
 			d = -f * Math.PI * 2;
-			if(minecraft.theWorld.dimension == Dimension.nether) {
+			if(mc.theWorld.dimension == Dimension.nether) {
 				d = Math.random() * Math.PI * 2;
 			}
 		}
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
index e916ec6e3..b79b8a49c 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
@@ -9,7 +9,7 @@ import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.Dimension;
 
-public class DynamicTextureCompass extends DynamicTexture{
+public class DynamicTextureCompass extends DynamicTexture {
 	
 	private Minecraft mc;
 	
@@ -21,10 +21,13 @@ public class DynamicTextureCompass extends DynamicTexture{
 	private double scaleFactor;
 	
 	public DynamicTextureCompass(Minecraft minecraft) {
-		super(TextureRegistry.getTexture("minecraft:item/tool_compass"));
-		
 		this.mc = minecraft;
+	}
 
+	@Override
+	public void postInit() {
+		setTexture(TextureRegistry.getTexture("minecraft:item/tool_compass"));
+		
 		BufferedImage atlas = texture.parentAtlas.atlas;
 		compassImageData = new byte[texture.getArea() * 4];
 
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
index 2995f22ed..4c9c09f0e 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
@@ -1,17 +1,19 @@
 package net.minecraft.client.render.dynamictexture;
 
+import java.awt.image.BufferedImage;
+import java.util.Random;
+
 import com.b100.json.element.JsonObject;
+
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.render.texturepack.TexturePackException;
 import net.minecraft.client.util.helper.TexturePackJsonHelper;
 import net.minecraft.client.util.helper.Textures;
 
-import java.awt.image.BufferedImage;
-import java.util.Random;
-
-public class DynamicTextureCustom extends DynamicTexture{
+public class DynamicTextureCustom extends DynamicTexture {
 	
 	private static Random rand = new Random();
 	
@@ -22,46 +24,29 @@ public class DynamicTextureCustom extends DynamicTexture{
 	private int frametime = 1;
 	private boolean random = false;
 	private boolean interpolate = false;
+	private boolean tile2x2 = false;
 	
 	private int currentFrame = -1;
 	private int previousFrame = -1;
 	private int nextFrameDelay = 0;
 	
-	public DynamicTextureCustom(Minecraft mc, String animationSource, IconCoordinate textureIndex) {
-		super(textureIndex);
-
-		TexturePack texturePack = mc.texturePackList.getHighestPriorityPack();
-		BufferedImage image = Textures.readImage(mc.texturePackList.getResourceAsStream(animationSource));
-
+	public DynamicTextureCustom(Minecraft mc, TexturePack texturePack, String animationSource, String texturePath, boolean shouldBeTiled) {
+		IconCoordinate texture = TextureRegistry.getTexture(texturePath);
+		
+		BufferedImage image = Textures.readImage(texturePack.getResourceAsStream(animationSource));
 		try {
-			if(image == null){
+			if(image == null) {
 				throw new TexturePackException("Could not load image!");
 			}
-			if(image.getWidth() != textureIndex.width) {
-				throw new TexturePackException("Invalid width! Expected " + textureIndex.width + " but got " + image.getWidth() + "!");
-			}
 			if(image.getHeight() < image.getWidth()) {
 				throw new TexturePackException("Height is smaller than width!");
-			}	
+			}
 		}catch (TexturePackException e) {
 			throw new TexturePackException("Error in animation " + animationSource, e);
 		}
-		
+
 		frameCount = image.getHeight() / image.getWidth();
 		
-		System.out.println("Frame Count: " + frameCount);
-		
-		frameData = new byte[textureIndex.getArea() * 4 * frameCount];
-		
-		for(int frame=0; frame < frameCount; frame++) {
-			for(int x=0; x < textureIndex.width; x++) {
-				for(int y=0; y < textureIndex.width; y++) {
-					int c = image.getRGB(x, frame * textureIndex.height + y);
-					putPixel(frameData, frame * textureIndex.getArea() + y * textureIndex.width + x, c);
-				}
-			}
-		}
-		
 		String jsonFilePath = animationSource.replace(".png", ".json");
 		if(texturePack.hasFile(jsonFilePath)) {
 			try {
@@ -85,10 +70,47 @@ public class DynamicTextureCustom extends DynamicTexture{
 						}
 					}
 				}
+				if(rootObject.has("tile2x2")) {
+					this.tile2x2 = TexturePackJsonHelper.getBoolean(rootObject, "tile2x2");
+				}
 			}catch (Exception e) {
 				throw new TexturePackException("Error in " + jsonFilePath, e);
 			}
 		}
+		
+		int tileCount = 1;
+		if(tile2x2) {
+			tileCount = 2;
+		}
+		
+		int res = image.getWidth();
+		int tiledRes = res * tileCount;
+		
+		texture.setDimension(tiledRes, tiledRes);
+		texture.parentAtlas.dontSetSize.add(texture);
+		setTexture(texture);
+		
+		frameData = new byte[tiledRes * tiledRes * 4 * frameCount];
+		for(int frame=0; frame < frameCount; frame++) {
+			for(int x=0; x < res; x++) {
+				for(int y=0; y < res; y++) {
+					int c = image.getRGB(x, frame * res + y);
+					for(int tileX = 0; tileX < tileCount; tileX++) {
+						for(int tileY = 0; tileY < tileCount; tileY++) {
+							int x1 = tileX * res + x;
+							int y1 = tileY * res + y;
+							int i = frame * tiledRes * tiledRes + y1 * tiledRes + x1;
+							putPixel(frameData, i, c);
+						}
+					}
+				}
+			}
+		}
+	}
+
+	@Override
+	public void postInit() {
+		
 	}
 	
 	@Override
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java
index ce690f042..84c9e5f2a 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.dynamictexture;
 
-import net.minecraft.client.render.stitcher.AtlasStitcher;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 
 public class DynamicTextureFire extends DynamicTexture{
@@ -11,16 +10,14 @@ public class DynamicTextureFire extends DynamicTexture{
 	private int height;
 	private float scaleFactor;
 	
-	public DynamicTextureFire() {
-		super(TextureRegistry.getTexture("minecraft:block/fire"));
-		
+	@Override
+	public void postInit() {
+		setTexture(TextureRegistry.getTexture("minecraft:block/fire"));
 		scaleFactor = texture.height / 16.0f;
 		
 		height = (int) (20 * scaleFactor);
 		this.arr1 = new float[texture.width * (height + 4)];
 		this.arr2 = new float[texture.width * (height + 4)];
-		
-		
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
index 97ea14561..c14c68d6b 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
@@ -3,31 +3,39 @@ package net.minecraft.client.render.dynamictexture;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texturepack.TexturePackException;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.util.helper.MathHelper;
 
 import java.awt.image.BufferedImage;
 
-public class DynamicTextureFireflyJar
-    extends DynamicTexture
-{
+public class DynamicTextureFireflyJar extends DynamicTexture {
     private final byte[] originalData;
     private long ticks = 0;
 
-    public DynamicTextureFireflyJar(Minecraft minecraft, IconCoordinate textureIndex)
-    {
-        super(textureIndex);
-
-        this.originalData = new byte[textureIndex.getArea() * 4];
-
-        BufferedImage image = Textures.readImage(minecraft.texturePackList.getResourceAsStream(TextureRegistry.blockAtlas.getSourceImagePath(textureIndex.namespaceId)));
-
-        for (int x = 0; x < textureIndex.width; x++) {
-            for (int y = 0; y < textureIndex.height; y++) {
-                putPixel(originalData, y * textureIndex.width + x, image.getRGB(x, y));
-            }
-        }
-    }
+	public DynamicTextureFireflyJar(Minecraft mc, String animationSource, String texturePath) {
+		BufferedImage image = Textures.readImage(mc.texturePackList.getResourceAsStream(animationSource));
+		if(image == null) {
+			throw new TexturePackException("Could not load image!");
+		}
+		this.originalData = new byte[image.getWidth() * image.getHeight() * 4];
+
+		IconCoordinate texture = TextureRegistry.getTexture(texturePath);
+		texture.setDimension(image.getWidth(), image.getHeight());
+		texture.parentAtlas.dontSetSize.add(texture);
+		setTexture(texture);
+		
+		for(int x = 0; x < texture.width; x++) {
+			for(int y = 0; y < texture.height; y++) {
+				putPixel(originalData, y * texture.width + x, image.getRGB(x, y));
+			}
+		}
+	}
+
+	@Override
+	public void postInit() {
+		
+	}
 
     private float getInternalBrightness()
     {
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java
index b076406b1..fd6c73dda 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java
@@ -1,7 +1,5 @@
 package net.minecraft.client.render.dynamictexture;
 
-import net.minecraft.client.render.block.model.BlockModelStandard;
-import net.minecraft.client.render.stitcher.AtlasStitcher;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.MathHelper;
 
@@ -13,9 +11,10 @@ public class DynamicTextureLavaFlowing extends DynamicTexture {
 	private float[] arr4;
 	private int ticks = 0;
 
-	public DynamicTextureLavaFlowing() {
-		super(TextureRegistry.getTexture("minecraft:block/lava_flowing"));
-
+	@Override
+	public void postInit() {
+		setTexture(TextureRegistry.getTexture("minecraft:block/lava_flowing"));
+		
 		arr1 = new float[texture.getArea()];
 		arr2 = new float[texture.getArea()];
 		arr3 = new float[texture.getArea()];
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaStill.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaStill.java
index d61eafb81..fd28296fe 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaStill.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaStill.java
@@ -1,7 +1,5 @@
 package net.minecraft.client.render.dynamictexture;
 
-import net.minecraft.client.render.block.model.BlockModelStandard;
-import net.minecraft.client.render.stitcher.AtlasStitcher;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.MathHelper;
 
@@ -12,9 +10,10 @@ public class DynamicTextureLavaStill extends DynamicTexture {
 	private float[] arr3;
 	private float[] arr4;
 
-	public DynamicTextureLavaStill() {
-		super(TextureRegistry.getTexture("minecraft:block/lava_still"));
-
+	@Override
+	public void postInit() {
+		setTexture(TextureRegistry.getTexture("minecraft:block/lava_still"));
+		
 		arr1 = new float[texture.getArea()];
 		arr2 = new float[texture.getArea()];
 		arr3 = new float[texture.getArea()];
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexturePortal.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexturePortal.java
index e793839dc..1fa41e4e5 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexturePortal.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexturePortal.java
@@ -7,11 +7,17 @@ import net.minecraft.core.util.helper.MathHelper;
 
 public class DynamicTexturePortal extends DynamicTexture{
 	
+	private boolean altTexture;
 	private int portalTickCounter = 0;
 	private byte[][] portalTextureData;
 	
 	public DynamicTexturePortal(boolean altTexture) {
-		super(TextureRegistry.getTexture("minecraft:block/portal_nether"));
+		this.altTexture = altTexture;
+	}
+
+	@Override
+	public void postInit() {
+		setTexture(TextureRegistry.getTexture("minecraft:block/portal_nether"));
 		Random var1 = new Random(100L);
 		
 		portalTextureData = new byte[32][texture.getArea() * 4];
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureRotating.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureRotating.java
index a9c59731e..ca3dd61b4 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureRotating.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureRotating.java
@@ -10,7 +10,7 @@ import net.minecraft.core.util.helper.MathHelper;
 
 public abstract class DynamicTextureRotating extends DynamicTexture {
 
-	protected final Minecraft minecraft;
+	protected final Minecraft mc;
 
 	protected byte[] dialImageData;
 	protected int dialTexRes;
@@ -20,17 +20,20 @@ public abstract class DynamicTextureRotating extends DynamicTexture {
 	protected double angleFinal;
 	protected double delta;
 
-	public DynamicTextureRotating(Minecraft minecraft, IconCoordinate textureIndex) {
-		super(textureIndex);
-
-		this.minecraft = minecraft;
-		clockImageData = new byte[textureIndex.getArea() * 4];
-
-		BufferedImage atlas = textureIndex.parentAtlas.atlas;
-		
-		for (int x = 0; x < textureIndex.width; x++) {
-			for (int y = 0; y < textureIndex.height; y++) {
-				putPixel(clockImageData, y * textureIndex.width + x, atlas.getRGB(textureIndex.iconX + x, textureIndex.iconY + y));
+	public DynamicTextureRotating(Minecraft minecraft, IconCoordinate texture) {
+		this.mc = minecraft;
+		this.texture = texture;
+	}
+	
+	@Override
+	public void postInit() {
+		setTexture(texture);
+
+		BufferedImage atlas = texture.parentAtlas.atlas;
+		clockImageData = new byte[texture.getArea() * 4];
+		for (int x = 0; x < texture.width; x++) {
+			for (int y = 0; y < texture.height; y++) {
+				putPixel(clockImageData, y * texture.width + x, atlas.getRGB(texture.iconX + x, texture.iconY + y));
 			}
 		}
 	}
